<template>
  <v-card>
    <div v-if="loading" class="text-center">
      <v-spinner />
    </div>
    <v-alert v-else-if="error" />
    <div v-else class="bus-lines-nav">
      <v-button
        v-for="(busLine, idx) in busLineList"
        :key="idx"
        size="sm"
        @click="selectLine(busLine)"
        :active="busLine === selectedBusLine"
      >
        {{ busLine }}
      </v-button>
    </div>
  </v-card>
</template>

<script setup lang="ts">
import VButton from '@/ui/v-button/VButton.vue';
import VCard from '@/ui/v-card/VCard.vue';
import VSpinner from '@/ui/v-spinner/VSpinner.vue';
import VAlert from '@/ui/v-alert/VAlert.vue';

defineProps<{
  busLineList: Array<number>;
  selectedBusLine?: number;
  loading?: boolean;
  error?: boolean;
}>();

const emit = defineEmits<{
  (e: 'update:selected-bus-line', busLine: number): void;
}>();

const selectLine = (line: number) => {
  emit('update:selected-bus-line', line);
};
</script>

<style>
.bus-lines-nav {
  display: flex;
  gap: 0.5rem;
  flex-wrap: wrap;
}
</style>
